--[[
	TODO:
		* Echo out the name of the quest when you check it (would require some way of getting a quest's name from its ID)
	CHANGELOG:
		1.0  : Initial release.
		1.1  : Added quest link support
		1.2  : Updated toc version to 4.2; Addon now auto-updates the database when you check a quest, if possible
		1.2.1: Removed some debug lines I forgot about, oops, also updated to 4.3
		1.2.2: Updated for 5.0.4
		1.2.3: Updated TOC version to 5.1
		1.24 : Updated TOC version to 5.2
		1.25 : Updated TOC version to 5.3
]]

function QQ_OnLoad(self)
	local f = CreateFrame("Frame","QueryQuestFrame",UIParent)
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	SLASH_QUERYQUEST1, SLASH_QUERYQUEST2 = '/qq', '/queryquest'
	qqVersion = GetAddOnMetadata("QueryQuest","Version")
end

function QQ_OnEvent(self, event, ...)
	
	if (event == "PLAYER_ENTERING_WORLD") then
		completedQuests = false
		qqQuest = 0
	end
end

function QQ_Msg(msg)
	DEFAULT_CHAT_FRAME:AddMessage("|cffd2b48c[QueryQuest]|r "..msg)
end

local function QQ_Slash(cmd)
	if (strmatch(cmd,"^%d+$")) then -- Just a number
		completedQuests = GetQuestsCompleted(completedQuests)
		QQ_Check(cmd)
		
	elseif (strmatch(cmd,"|Hquest")) then -- Quest link
		completedQuests = GetQuestsCompleted(completedQuests)
		local questid = strmatch(cmd,"|Hquest:(%d+):")
		QQ_Check(questid)
		
	elseif ((cmd == "v") or (cmd == "version")) then -- version request
		QQ_Msg("QueryQuest version "..qqVersion)
		
	else -- nothing or maybe help
		QQ_Msg("QueryQuest commands:")
		QQ_Msg("/qq xxxxx - See if you've completed the quest with ID xxxxx")
		QQ_Msg("/qq [Quest Link] - See if you've completed the given quest")
		QQ_Msg("/qq v[ersion] - Show addon version")
		QQ_Msg("/qq help - Show this help")
		QQ_Msg("To get a quest's ID, look it up on wowhead.com and copy the number at the end of the URL")
	end
end
SlashCmdList["QUERYQUEST"] = QQ_Slash

function QQ_Check(id)
	if (completedQuests[id+0]) then
		QQ_Msg("|cff00ff00That quest has been completed.|r")
	else
		QQ_Msg("|cffff0000That quest has NOT been completed.|r")
	end
end